module Rotacao where

import Tetromino
import Vetor

-- =========================================================================
-- Esse arquivo contem funcionalidades relativas a rotacoes dos tetrominos,
-- i.e. quais sao os offsets testados na hora de rotacionar uma peca
-- =========================================================================

-- =========================================================================
-- O tetromino I segue uma regra diferente para fazer os wall kicks, os demais
-- seguem todos a mesma regra. Cada offset sera aplicado na peca na ordem abaixo
-- sendo que o primeiro que nao causar colisoes e que nao fizer com que o bloco
-- o bloco saia do tabuleiro eh usado.
--                       Orientacao    Orientacao    Lista de offsets
--                       Inicial       Final         que serao testados
testesPadrao, testesI, testeO :: Orientacao -> Orientacao -> [Vetor2D]
testesPadrao OZero ORight = zipWith Vetor2D [0, (-1), (-1), 0, (-1)] [0, 0, (-1),    2,    2]
testesPadrao ORight OZero = zipWith Vetor2D [0,    1,    1, 0,    1] [0, 0,    1, (-2), (-2)]
testesPadrao ORight ODois = zipWith Vetor2D [0,    1,    1, 0,    1] [0, 0,    1, (-2), (-2)]
testesPadrao ODois ORight = zipWith Vetor2D [0, (-1), (-1), 0, (-1)] [0, 0, (-1),    2,    2]
testesPadrao ODois OLeft  = zipWith Vetor2D [0,    1,    1, 0,    1] [0, 0, (-1),    2,    2]
testesPadrao OLeft ODois  = zipWith Vetor2D [0, (-1), (-1), 0, (-1)] [0, 0,    1, (-2), (-2)]
testesPadrao OLeft OZero  = zipWith Vetor2D [0, (-1), (-1), 0, (-1)] [0, 0,    1, (-2), (-2)]
testesPadrao OZero OLeft  = zipWith Vetor2D [0,    1,    1, 0,    1] [0, 0, (-1),    2,    2]

testesI OZero ORight = zipWith Vetor2D [0, (-2),    1, (-2),    1] [0, 0, 0,    1, (-2)]
testesI ORight OZero = zipWith Vetor2D [0,    2, (-1),    2, (-1)] [0, 0, 0, (-1),    2]
testesI ORight ODois = zipWith Vetor2D [0, (-1),    2, (-1),    2] [0, 0, 0, (-2),    1]
testesI ODois ORight = zipWith Vetor2D [0,    1, (-2),    1, (-2)] [0, 0, 0,    2, (-1)]
testesI ODois OLeft  = zipWith Vetor2D [0,    2, (-1),    2, (-1)] [0, 0, 0, (-1),    2]
testesI OLeft ODois  = zipWith Vetor2D [0, (-2),    1, (-2),    1] [0, 0, 0,    1, (-2)]
testesI OLeft OZero  = zipWith Vetor2D [0,    1, (-2),    1, (-2)] [0, 0, 0,    2, (-1)]
testesI OZero OLeft  = zipWith Vetor2D [0, (-1),    2, (-1),    2] [0, 0, 0, (-2),    2]

testeO _ _ = [Vetor2D 0 0]

-- =========================================================================
-- Essa funcao sera chamada para determinar qual funcao de testes usar para
-- o tetromino que sera rodado
escolheTestes :: Tetromino -> (Orientacao -> Orientacao -> [Vetor2D])
escolheTestes tet
    | tet == tetroI = testesI
    | tet == tetroO = testeO
    | otherwise     = testesPadrao
